#include <IRstD.h>

IRrecvstd irrecvstd(10); // пин приёмника (можно любой кроме пина передатчика)
IRsendstd irsendstd;     // пин передатчика для Duemilanove, Diecimila, LilyPad, Mini, Fio, Nano - 9, для Мега - 5 
                         // менять пин передатчика в файле IRremoteInt.h  
decode_resultsstd res_std;

int BUTTON_PIN2 = 11;
int STATUS_PIN2= 13;


void setup()
{
  Serial.begin(57600);
  irrecvstd.enableIRInstd(); // Старт приёмник
  pinMode(BUTTON_PIN2, INPUT);
  pinMode(STATUS_PIN2, OUTPUT);
}


int codeType2 = -1; 
unsigned long codeValue2; 
unsigned int rawCodes2[RAWBUFstd]; 
int codeLen2; 
int toggle2 = 0; 


void storeCode(decode_resultsstd *res_std) {
  
  codeType2 = res_std->decode_typestd;
  int count2 = res_std->rawlenstd;
  
  if (codeType2 == UNKNOWNstd) {
    Serial.println("Received unknown code, saving as raw");
    codeLen2 = res_std->rawlenstd - 1;
    
    for (int i = 1; i <= codeLen2; i++) {
      if (i % 2) {
        
        rawCodes2[i - 1] = res_std->rawbufstd[i]*USECPERTICK - MARK_EXCESS;
        Serial.print(" m");
      } 
      else {
       
        rawCodes2[i - 1] = res_std->rawbufstd[i]*USECPERTICK + MARK_EXCESS;
        Serial.print(" s");
      }
      Serial.print(rawCodes2[i - 1], DEC);
    }
    Serial.println("");
  }
  else {
    if (codeType2 == NECstd) {
      Serial.print("Received NEC: ");
      if (res_std->valuestd == REPEATstd) {
       
        Serial.println("repeat; ignoring.");
        return;
      }
    } 
    else if (codeType2 == SONYstd) {
      Serial.print("Received SONY: ");
    } 
    else if (codeType2 == RC5std) {
      Serial.print("Received RC5: ");
    } 
    else if (codeType2 == RC6std) {
      Serial.print("Received RC6: ");
    } 
    else {
      Serial.print("Unexpected codeType ");
      Serial.print(codeType2, DEC);
      Serial.println("");
    }
    Serial.println(res_std->valuestd, HEX);
    codeValue2 = res_std->valuestd;
    codeLen2 = res_std->bitsstd;
  }
}

void sendCode(int repeat) {
  if (codeType2 == NECstd) {
    if (repeat) {
      irsendstd.sendNECstd(REPEATstd, codeLen2);
      Serial.println("Sent NEC repeat");
    } 
    else {
      irsendstd.sendNECstd(codeValue2, codeLen2);
      Serial.print("Sent NEC ");
      Serial.println(codeValue2, HEX);
    }
  } 
  else if (codeType2 == SONYstd) {
    irsendstd.sendSonystd(codeValue2, codeLen2);
    Serial.print("Sent Sony ");
    Serial.println(codeValue2, HEX);
  } 
  else if (codeType2 == RC5std || codeType2 == RC6std) {
    if (!repeat) {
    
      toggle2 = 1 - toggle2;
    }

    codeValue2 = codeValue2 & ~(1 << (codeLen2 - 1));
    codeValue2 = codeValue2 | (toggle2 << (codeLen2 - 1));
    if (codeType2 == RC5std) {
      Serial.print("Sent RC5 ");
      Serial.println(codeValue2, HEX);
      irsendstd.sendRC5std(codeValue2, codeLen2);
    } 
    else {
      irsendstd.sendRC6std(codeValue2, codeLen2);
      Serial.print("Sent RC6 ");
      Serial.println(codeValue2, HEX);
    }
  } 
  else if (codeType2 == UNKNOWNstd /* i.e. raw */) {
    // Assume 38 KHz
    irsendstd.sendRawstd(rawCodes2, codeLen2, 38);
    Serial.println("Sent raw");
  }
}

int lastButtonState;

void loop() 
{
  
  int buttonState = digitalRead(BUTTON_PIN2);
  if (lastButtonState == HIGH && buttonState == LOW) {
    Serial.println("Released");
    irrecvstd.enableIRInstd(); 
  }

  if (buttonState) {
    Serial.println("Pressed, sending");
    digitalWrite(STATUS_PIN2, HIGH);
    sendCode(lastButtonState == buttonState);
    digitalWrite(STATUS_PIN2, LOW);
    delay(50); 
  } 
  else if (irrecvstd.decodestd(&res_std)) {
    digitalWrite(STATUS_PIN2, HIGH);
    storeCode(&res_std);
    irrecvstd.resumestd(); // resume receiver
    digitalWrite(STATUS_PIN2, LOW);
  }
  lastButtonState = buttonState;
}
