
#include <IRstD.h>

IRrecvstd irrecvstd(10); // пин приёмника (можно любой кроме пина передатчика)
IRsendstd irsendstd;     // пин передатчика для Duemilanove, Diecimila, LilyPad, Mini, Fio, Nano - 9, для Мега - 5 
                         // менять пин передатчика в файле IRremoteInt.h  
decode_resultsstd res_std;


void setup()
{
  Serial.begin(57600);
  irrecvstd.enableIRInstd(); // Старт приёмник
}


void dump(decode_resultsstd *res_std) {

  int count = res_std->rawlenstd;
  if (res_std->decode_typestd == UNKNOWNstd) {
    Serial.print("Unknown encoding: ");
  }
  else if (res_std->decode_typestd == NECstd) {
    Serial.print("Decoded NEC: ");

  }
  else if (res_std->decode_typestd == SONYstd) {
    Serial.print("Decoded SONY: ");
  }
  else if (res_std->decode_typestd == RC5std) {
    Serial.print("Decoded RC5: ");
  }
  else if (res_std->decode_typestd == RC6std) {
    Serial.print("Decoded RC6: ");
  }
  else if (res_std->decode_typestd == PANASONICstd) {
    Serial.print("Decoded PANASONIC - Address: ");
    Serial.print(res_std->addressstd, HEX);
    Serial.print(" Value: ");
  }
  else if (res_std->decode_typestd == LGstd) {
    Serial.print("Decoded LG: ");
  }
  else if (res_std->decode_typestd == JVCstd) {
    Serial.print("Decoded JVC: ");
  }
  else if (res_std->decode_typestd == AIWA_RC_T501std) {
    Serial.print("Decoded AIWA RC T501: ");
  }
  else if (res_std->decode_typestd == WHYNTERstd) {
    Serial.print("Decoded Whynter: ");
  }
  Serial.print(res_std->valuestd, HEX);
  Serial.print(" (");
  Serial.print(res_std->bitsstd, DEC);
  Serial.println(" bits)");
  Serial.print("Raw (");
  Serial.print(count, DEC);
  Serial.print("): ");

  for (int i = 1; i < count; i++) {
    if (i & 1) {
      Serial.print(res_std->rawbufstd[i]*USECPERTICK, DEC);
    }
    else {
      Serial.write('-');
      Serial.print((unsigned long) res_std->rawbufstd[i]*USECPERTICK, DEC);
    }
    Serial.print(" ");
  }
  Serial.println();
}

void loop() {
  if (irrecvstd.decodestd(&res_std)) {
    Serial.println(res_std.valuestd);
    dump(&res_std);
    irrecvstd.resumestd(); // Receive the next value
  }
}
