#include <IRstD.h>

int RELAY_PIN = 4;

IRrecvstd irrecvstd(10); // пин приёмника (можно любой кроме пина передатчика)
                         // пин передатчика для Duemilanove, Diecimila, LilyPad, Mini, Fio, Nano - 9, для Мега - 5
decode_resultsstd res_std;


void dump(decode_resultsstd *res_std) {
  int count = res_std->rawlenstd;
  if (res_std->decode_typestd == UNKNOWNstd) {
    Serial.println("Could not decode message");
  } 
  else {
    if (res_std->decode_typestd == NECstd) {
      Serial.print("Decoded NEC: ");
    } 
    else if (res_std->decode_typestd == SONYstd) {
      Serial.print("Decoded SONY: ");
    } 
    else if (res_std->decode_typestd == RC5std) {
      Serial.print("Decoded RC5: ");
    } 
    else if (res_std->decode_typestd == RC6std) {
      Serial.print("Decoded RC6: ");
    }
    Serial.print(res_std->valuestd, HEX);
    Serial.print(" (");
    Serial.print(res_std->bitsstd, DEC);
    Serial.println(" bits)");
  }
  Serial.print("Raw (");
  Serial.print(count, DEC);
  Serial.print("): ");

  for (int i = 0; i < count; i++) {
    if ((i % 2) == 1) {
      Serial.print(res_std->rawbufstd[i]*USECPERTICK, DEC);
    } 
    else {
      Serial.print(-(int)res_std->rawbufstd[i]*USECPERTICK, DEC);
    }
    Serial.print(" ");
  }
  Serial.println("");
}

void setup()
{
  pinMode(RELAY_PIN, OUTPUT);
  pinMode(13, OUTPUT);
    Serial.begin(57600);
  irrecvstd.enableIRInstd(); // Start the receiver
}

int on = 0;
unsigned long last = millis();

void loop() {
  if (irrecvstd.decodestd(&res_std)) {
   
    if (millis() - last > 250) {
      on = !on;
      digitalWrite(RELAY_PIN, on ? HIGH : LOW);
      digitalWrite(13, on ? HIGH : LOW);
      dump(&res_std);
    }
    last = millis();      
    irrecvstd.resumestd(); 
  }
}
